<template>
    <div>
        <div class="padding">
            <h3>Контактная информация</h3>
        </div>
        <hr/>
        <div class="padding">
            <div class="row">
                <contact-mobile-phone-registation ref="ContactMobilePhone"></contact-mobile-phone-registation>
                <contact-email-registation ref="ContactEmail"></contact-email-registation>
            </div>
            <first-last-middle-name ref="InitialsOfUser"></first-last-middle-name>
            <div class="row" v-if="!$user.promo.percent && $config.promoCodeEnabled">
                <div class="columns four">
                    <label for="promoCode">Промо-код <span class="gray">(необязательно)</span></label>
                </div>
            </div>

            <!-- Блок виден, пока не было введено 3 попытки на проверку промокода-->
            <div class="row" v-if="displayPromoForm">
                <div class="columns four" style="position: relative">
                    <input type="text"
                           name="promoCode"
                           v-model="$user.promo.code"
                           id="promoCode"
                           :class="{error: hasErr}"
                           @keyup.enter="checkPromoCode"
                           autocomplete="off"
                           maxlength="12"
                    />
                    <transition name="fade">
                        <button
                                v-if="$user.promo.code.length"
                                class="blue input-button promo-code"
                                :class="{button_loading: $interface.buttonLoading}"
                                :disabled="$interface.buttonLoading"
                                @click="checkPromoCode">
                            &raquo;
                        </button>
                    </transition>
                    <p v-if="errPromoCode && $user.promo.count" class="red margin-top_-30">
                        Неверный код. Осталось попыток: {{$user.promo.count}}</p>
                </div>
            </div>
            <!--Один из двух ответов в случае ввденого промокода-->
            <div class="row" v-else>
                <transition name="fade">
                    <success-message v-if="$user.promo.percent">
                        <div slot="message">
                            Промокод <b>{{$user.promo.code}}</b> подтвержден! <br>
                            Процентная ставка снижена до <b>{{$user.promo.percent}}%</b> в день.
                        </div>
                    </success-message>
                </transition>
                <span class="promo" v-if="$user.promo.count === 0">Подайте заявку без использования промо-кода</span>
            </div>

        </div>
    </div>
</template>

<script>
  import FirstLastMiddleName from '@/components/User/PersonalInformation/FirstLastMiddleName'
  import FieldOfPhone from '@/pages/Registration/FieldsOfContacts/FieldOfPhone'
  import ContactMobilePhoneRegistation from '@/components/User/ContactInformation/ContactMobilePhoneRegistation'
  import ContactEmailRegistation from '@/components/User/ContactInformation/ContactEmailRegistation'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import {REQUIRED_FIELD, MIN_LENGHT, MAX_LENGHT} from '@/components/Validators/CustomVeeValidateMessage'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import Multiselect from '@/UI/Multiselect'
  import backendApi from '@/utils/backend-api'
  import SuccessMessage from "../../../components/AuxiliaryWindows/SuccessMessage";

  export default {
    data() {
      return {
        fieldControlQuestionType: [{id: 1, title: 'Девичья фамилия матери'}],
        controlQuestionTypeStatus: [
          {id: 1, title: 'Девичья фамилия матери'},
          {id: 2, title: 'Кличка домашнего животного'},
          {id: 3, title: 'Свой вопрос'}
        ],
        promoCode: '',
        noErrPromoCode: false,
        errPromoCode: false,
        hasErr: false
      }
    },
    components: {
      SuccessMessage,
      FieldOfPhone,
      FirstLastMiddleName,
      ContactMobilePhoneRegistation,
      ContactEmailRegistation,
      ValidateMessage,
      Multiselect
    },
    computed: {
      displayPromoForm() {
        if (!this.$config.promoCodeEnabled) return false;

        if (this.$user.promo.check) {
          return false
        }
        if (this.$user.promo.count === 0) {
          this.$user.promo.code = '';
          return false
        }
        return true
      }
    },
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass,
      IndicatorRegistration,
      ErrorHandleMixin
    ],
    mounted() {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_LENGHT)
      this.$validator.localize(MAX_LENGHT)
    },
    methods: {
      checkPromoCode() {
        if (!this.$user.promo.code) {
          this.hasErr = true
          return
        }
        this.errPromoCode = false
        this.hasErr = false
        this.BUTTON_LOADING(true)
        backendApi.postData('calculator-loan', {
          promo_code: this.$user.promo.code
        }).then(response => {
          this.noErrPromoCode = true
          this.errPromoCode = false
          this.hasErr = false
          this.$user.promo.check = true;
          this.$user.promo.percent = response.data.data.percent;
          this.$toastr.success(`Промокод подтвержден! Процентная ставка снижена до ${this.$user.promo.percent}% в день.`, 'Успешно')
        }).catch(() => {
          this.errPromoCode = true
          this.hasErr = true
          this.noErrPromoCode = false
          this.$user.promo.check = false
          this.$user.promo.count--;
          this.$toastr.warning('Введенный промокод не существует или истек срок его действия.', 'Ошибка');
        }).finally(() => {
          this.BUTTON_LOADING(false);
        })
      }

    }
  }
</script>

<style scoped lang="scss">
    .slide-fade-enter-active {
        transition: all .3s ease
    }

    .slide-fade-leave-active {
        transition: all .3s ease
    }

    .slide-fade-enter, .slide-fade-leave-to {
        transform: translateY(10px);
        opacity: 0;
    }

    .slide-fade-leave-to {
        transform: translateY(10px);
        opacity: 0;
    }

    .margin-top_-30 {
        margin-top: -30px
    }

    .error {
        background: #fff0ed;
        color: #ff6d4a;
        border-color: #ffd6ce !important;
    }

    .promo {
        display: flex;
        align-items: center;
        height: 40px;
        font-weight: 300;
    }

    button.promo-code {
        position: absolute;
        top: 0;
        right: 0;
        border-top-left-radius: 0;
        border-bottom-left-radius: 0;
        margin-right: 0;
    }
</style>
